dnl
dnl Define default makefile headers and footers
dnl
define(LAC_MAKEFILE_DEFAULT_HEADERS, LAC_DIR/Make-Header.in)
define(LAC_MAKEFILE_DEFAULT_FOOTERS, LAC_DIR/Make-Footer.in)

dnl
dnl Add a new makefile header to the end of a header list
dnl
AC_DEFUN(LAC_MAKEFILE_HEADER,
[
    if test "${lac_makefile_headers_$1=""}" = "" ; then
        lac_makefile_headers_$1="$2"
    else
        lac_makefile_headers_$1="${lac_makefile_headers_$1}:$2"
    fi
])

dnl
dnl
dnl Add a new makefile footer to the end of a footer list
dnl
AC_DEFUN(LAC_MAKEFILE_FOOTER,
[
    if test "${lac_makefile_footers_$1=""}" = "" ; then
        lac_makefile_footers_$1="$2"
    else
        lac_makefile_footers_$1="${lac_makefile_footers_$1}:$2"
    fi
])

dnl
dnl Add a new make file to the list to be generated
dnl
AC_DEFUN(LAC_MAKEFILE_INSERT,
[
    tmp="$2"
    if test "${lac_makefile_headers_$1=""}" != "" ; then
        tmp="${tmp}:${lac_makefile_headers_$1=""}"
    fi
    tmp="${tmp}:$2.in"
    if test "${lac_makefile_footers_$1=""}" != "" ; then
        tmp="${tmp}:${lac_makefile_footers_$1=""}"
    fi
    lac_makefiles="${lac_makefiles=""} $tmp"
])

dnl
dnl Get the list of makefiles
dnl
AC_DEFUN(LAC_MAKEFILE_DIR_LIST,
[
    ${lac_makefiles=""}
])
