AC_DEFUN(LAC_UTILS_INIT,
[
    OBJ_FILE=".o"
    EXEC_FILE=""
    DEV_NULL='/dev/null'
    PATH_SEP=":"

    case ${build_os} in
	cygwin32* | winnt*)
	    PATH_SEP=";"
            EXEC_FILE=".exe"
	    ;;
    esac


    AC_SUBST(OBJ_FILE)
    AC_SUBST(EXEC_FILE)
    AC_SUBST(PATH_SEP)
    AC_SUBST(DEV_NULL)

    changequote(<<,>>)

    dnl resolve_path(path, rel_path)
    dnl
    dnl Take a relative or absolute path and adjust it according to a relative
    dnl path of the form ./../.../..
    dnl
    resolve_path() {
    	src_path="$<<1>>"
    	rel_path="$<<2>>"
    	while test "${rel_path}" != "." ; do
    	    rel_path=`echo "${rel_path}" | sed 's-/..--'`
    	    src_path=`echo "${src_path}" | sed 's-/[^/]*$--'`
    	done
    	echo "$src_path"
    }

    dnl make_relative_path(abs_path, rel_path)
    dnl
    dnl Take the supplied absolute path and return a relative path
    dnl based on the depth of the supplied relative path.
    dnl
    make_relative_path() {
    	src_path="$<<1>>"
    	rel_path="$<<2>>"
	new_path=""
    	while test "${rel_path}" != "." ; do
    	    rel_path=`echo "${rel_path}" | sed 's-/..--'`
            new_path="/`echo "${src_path}" | sed 's-.*/--'`${new_path}"
    	    src_path=`echo "${src_path}" | sed 's-/[^/]*$--'`
    	done
    	echo ".$new_path"
    }

    changequote([,])
])

AC_DEFUN(LAC_UTILS_PATHS,
[
    dnl
    dnl Compute and publish source and build directory paths
    dnl
    rel_configdir=LAC_DIR
    if test "X${prefix}" = "XNONE" ; then
        prefix="`pwd`/INSTALL"
    fi

    AC_SUBST(rel_configdir)

    dnl
    dnl Determine and publish paths to common utilities
    dnl
    AC_PATH_PROG(LN, ln)
    AC_PROG_LN_S
    AC_PROG_MAKE_SET
    AC_PATH_PROG(MKDIR, mkdir)
    AC_PATH_PROG(RM, rm)
    AC_PATH_PROG(RMDIR, rmdir)
    AC_PATH_PROG(SED, sed)
    AC_PATH_PROG(TRUE, true)

    dnl
    dnl Test for the existence of cd or chdir since bash v2 appeara to only
    dnl support cd
    dnl
    LAC_MSG_DETERMINING([appropriate chdir command])
    if ( chdir >/dev/null 2>&1 ) ; then
        CHDIR=chdir
    elif ( cd >/dev/null 2>&1 ) ; then
        CHDIR=cd
    else
        CHDIR=no
    fi
    AC_MSG_RESULT([${CHDIR}])
    AC_SUBST(CHDIR)
])
