#include "CIF_Shared_State_def.H"
#include "globus_common.h"

#define ATTACH_INT  31212

globus_bool_t                        global_done;
globus_mutex_t                       global_mutex;
globus_cond_t                        global_cond;

int
next_int(
    int                             last_int);

float
next_float(
    float                             last_float);

class
Int_Tester : public CIF_Shared_State_Callback_Interface
{
protected:
   CIF_Shared_State_Int *                   sharedInt;
   CIF_Shared_State_Set *                   sharedSet;
   int                                      last_int;
   globus_bool_t                            my_turn;
   globus_bool_t                            master_Flag;

public:
    Int_Tester(
	char *                              url);

    ~Int_Tester();

    void
    start_Test();
	
    virtual void  
    state_Changed(
	CIF_Shared_State *                  shared_state,
        CIF_Shared_State_Changed_Type       type,
	CIF_Shared_State_Set_GUID *         guid);

};

Int_Tester::Int_Tester(
    char *                                  url)
{
    last_int = 0;
    if(url == GLOBUS_NULL)
    {
        sharedSet = new CIF_Shared_State_Set(CIF_MESSENGER_TYPE_TCP);
        master_Flag = GLOBUS_TRUE;
        printf("url = %s\n", sharedSet->get_Message_Space_URL());
    }
    else
    {
        printf("joing set\n");
        sharedSet = new CIF_Shared_State_Set(CIF_MESSENGER_TYPE_TCP, url);
        printf("joined set\n");
        master_Flag = GLOBUS_FALSE;
    }
    my_turn = GLOBUS_FALSE;
    sharedInt = new CIF_Shared_State_Int(
        (char *)"MY_ASS", 
        1,
        (CIF_Shared_State_Callback_Interface *) this);
    last_int = 0;

    printf("adding shared state\n");
    sharedSet->add_Shared_State(sharedInt);

    if(!master_Flag)
    {
        int                             val[1];
     
        val[0] = ATTACH_INT;
        sharedInt->set_State_Changed(0, val, 0, 1, FINAL);
        
        printf("Client attached and sent attach message\n");
        my_turn = GLOBUS_TRUE;

        last_int = next_int(last_int);
        val[0] = last_int;
        sharedInt->set_State_Changed(0, val, 0, 1, FINAL);
    }
}

Int_Tester::~Int_Tester()
{
    printf("closing set\n");
    sharedSet->close();
    delete sharedSet;
}

void 
Int_Tester::state_Changed(
        CIF_Shared_State *                  shared_state,
        CIF_Shared_State_Changed_Type       type,
	CIF_Shared_State_Set_GUID *         guid)
{
    int                                     val[1];

    sharedInt->get_State(val, 0, 0, 1);
    printf("int value is %d\n", val[0]);

    if(!master_Flag)
    {
        printf("signaling end\n");
        globus_mutex_lock(&global_mutex);
	{
            global_done = GLOBUS_TRUE;
            globus_cond_signal(&global_cond);
	}
	globus_mutex_unlock(&global_mutex);
    }
}

/*
 * create a float and an int and have both guys change number
 */
int 
main(
    int                             argc, 
    char *                          argv[])
{
    char *                           url;
    Int_Tester *                     test;


    CIF_Comm::activate();

    globus_mutex_init(&global_mutex, NULL);
    globus_cond_init(&global_cond, NULL);
    global_done = GLOBUS_FALSE;

    if(argc < 2)
    {
        url = GLOBUS_NULL;
    }
    else
    {
        url = argv[1];
    }

    test = new Int_Tester(url);
 
    printf("waiting to end\n"); 
    globus_mutex_lock(&global_mutex);
    {
        while(!global_done)
        {
            globus_cond_wait(&global_cond, &global_mutex);
        }
    }
    globus_mutex_unlock(&global_mutex);
    printf("ending\n"); 

    delete test;

    CIF_Comm::deactivate();
}

int
next_int(
    int                             last_int)
{
    return (last_int+1);
}

float
next_float(
    float                             last_float)
{
    return (last_float + 1.5);
}

