/******************************************************************************
Description:

  Error/status code class

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/comm/CIF_Comm_Status.C,v $
  $Date: 1998/09/28 20:16:23 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#include "CIF_Comm_Status.H"
#include <stdio.h>

#if !defined(CIF_USE_INLINES)

CIF_Comm_Status::CIF_Comm_Status()
: l_status(SUCCESS)
{
}

    
CIF_Comm_Status::CIF_Comm_Status(
    const CIF_Comm_Status &			status)
: l_status(status.l_status)
{
}

    
CIF_Comm_Status::CIF_Comm_Status(
    const int					status)
: l_status(status)
{
}

    
CIF_Comm_Status &
CIF_Comm_Status::operator =(
    const int					status)
{
    l_status = status;
    return *this;
}

    
CIF_Comm_Status &
CIF_Comm_Status::operator =(
    const CIF_Comm_Status &			status)
{
    l_status = status.l_status;
    return *this;
}

    
CIF_Comm_Status::operator int() const
{
    return l_status;
}

#endif /* CIF_DEFINE_INLINES */


const char *
CIF_Comm_Status::get_Description()
{
    switch (l_status)
    {
      case SUCCESS:
	return "succeeded";

      case FAILURE:
	return "failed";

      case OBJECT_ACTIVE:
	return "failed because the object is currently active/open";
    
      case OBJECT_INACTIVE:
	return "failed because the object is currently inactive/closed";

      case OBJECT_DELETED:
	return "failed because the object has been deleted "
	    "(NOTE: memory corruption has likely occurred)";
	
      case INSUFFICIENT_MEMORY:
	return "failed because the process has run out of memory";

      case URL_FORMAT_BAD:
	return "failed because the specfied URL was incorrectly formatted";
    
      case URL_SCHEME_UNSUPPORTED:
	return "failed because the specfied protocol is not supported";

      case TIMED_OUT:
	return "failed because the specifed time had elasped";

      case WOULD_BLOCK:
	return "failed because the operation would have blocked";

      case INTERNAL_ERROR:
	return "failed because an internal error occurred";

      default:
	static char				msg[1024];

	sprintf(msg, "failed with unknown error code %d\n", l_status);

	return msg;
    }
}

