/******************************************************************************
CIF_I_Comm_Listener_TCP.C

Description:

  Implementation of the CIF_Comm Listener class for TCP

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/comm/CIF_I_Comm_Listener_TCP.C,v $
  $Date: 1998/09/25 15:08:43 $
  $Revision: 1.3 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_I_Comm_Listener_TCP.H"
#include "CIF_I_Comm_Connection_TCP.H"


/******************************************************************************
		     Define CIF_I_Comm_Listener_TCP methods
******************************************************************************/


CIF_Comm_Connection *
CIF_I_Comm_Listener_TCP::open_Connection(
    nexus_buffer_t &				buffer,
    ARG_IN const
    CIF_Comm_Connection::Properties &		properties,
    ARG_IN const CIF_Toolkit_Timeout &		timeout)
{
    CIF_I_Comm_Connection_TCP *			conn;

    conn = new CIF_I_Comm_Connection_TCP;
    if (conn->open(buffer, properties, timeout) == false)
    {
	delete conn;
	return (CIF_Comm_Connection *) CIF_NULL;
    }

    return (CIF_Comm_Connection *) conn;
}


char *
CIF_I_Comm_Listener_TCP::get_URL_Scheme()
{
    return CIF_COMM_PROTOCOL_TCP_STR;
}

