/******************************************************************************
  CIF_I_Shared_State_Tools.h
  --------------------------

  Description:

    Abstract Shared_State class.

  CVS Information:

    $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/shared_state/CIF_I_Shared_State_Tools.H,v $
    $Date: 2000/03/01 18:41:46 $
    $Revision: 1.6 $
    $State: Exp $
    $Author: bresnaha $
******************************************************************************/
#ifndef __CIF_I_SHARED_STATE_TOOLS
#define __CIF_I_SHARED_STATE_TOOLS

class CIF_Shared_State_Base;

#include "CIF_Shared_State_def.H"
#include "nexus.h"

class CIF_I_List_Node
{
protected:

public:
    CIF_I_List_Node *   next;
    void *              element;
    CIF_Byte *          key;
    int                 key_Len;

public:
    CIF_I_List_Node(void * element);
    CIF_I_List_Node(void * element, char * key);
    CIF_I_List_Node(void * element, CIF_Byte * key, int key_len);
};

class CIF_I_List : public CIF_Shared_State_Base
{
protected:
    int                 element_Count;
    CIF_I_List_Node *   last_Element;

public:
    CIF_I_List_Node * first_Element;

public:
    CIF_I_List();
    virtual ~CIF_I_List();

    void *     elementAt(int index);
    void *     element(char * element_key);
    void *     element(CIF_Byte * element_key, int key_len);
    void       addElement(void * obj);
    void       addElement(void * obj, char * key);
    void       addElement(void * obj, CIF_Byte * key, int key_len);
    CIF_Bool   removeElementAt(int index);
    CIF_Bool   removeElement(void * obj);
    CIF_Bool   removeElement(char * key);
    CIF_Bool   removeElement(CIF_Byte * key, int key_len);

    void       removeAllElements();
    int        getElementCount() 
	    	   {return element_Count;};
};

class CIF_I_Hash_Table : public CIF_Shared_State_Base
{
protected:
    CIF_I_List *        table_Array;
    int                 table_Size;

protected:
    int  calc_hash_index(char * key);

public:
    CIF_I_Hash_Table(int in_table_size);
    virtual ~CIF_I_Hash_Table();

    void *  getElement(char * key);
    void *  getElementNumber(int index); 
    void ** getEnumeration();
    void    putElement(char * key, void * obj);
    void    removeElement(char * key);

    int    getElementCount();
};

#endif
