/******************************************************************************
  CIF_Shared_State.h
  ------------------

  Description:

    Abstract Shared_State class.
  
  CVS Information:
    
    $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/shared_state/CIF_Shared_State.H,v $
    $Date: 2000/03/01 18:41:46 $
    $Revision: 1.6 $
    $State: Exp $
    $Author: bresnaha $
******************************************************************************/
	      
#ifndef __CIF_SHARED_STATE
#define __CIF_SHARED_STATE

#include <stdio.h>
#include "CIF_Shared_State_def.H"

/******************************************************************************
*                            class prototypes
******************************************************************************/
class CIF_Shared_State_Serial;
class I_CIF_List;

/******************************************************************************
*   CIF_Shared_State
*   ----------------
******************************************************************************/
class CIF_Shared_State : public CIF_Shared_State_Base
{

private:
    CIF_Byte                                    carp[10000];
    CIF_Bool                                    initialized;
protected:
    char *                                      shared_State_Name;
    CIF_Shared_State_Set *                      shared_State_Set; 
    CIF_I_List *                                callback_List;
    globus_mutex_t                              mutex;
    globus_cond_t                               cond;

public:
    CIF_Shared_State(
        char *                                   name);
    CIF_Shared_State(
        char *                                   name, 
        CIF_Shared_State_Callback_Interface *    callback);
  virtual ~CIF_Shared_State();

  void                   joined_Set(CIF_Shared_State_Set * set);
  CIF_Bool               get_Initialized();
  void                   set_Initialized(CIF_Bool b);
  char *                 get_Name();
  CIF_Shared_State_Set * get_Shared_State_Set() {return shared_State_Set;}

  virtual int            get_State_Count() = 0;
  virtual void           pack_State(CIF_Shared_State_Serial * serial) = 0;
  virtual void           unpack_State(CIF_Shared_State_Serial * serial) = 0;

  virtual void           state_Changed(CIF_Shared_State_Serial * serial,
				       CIF_Shared_State_Changed_Type type,
				       CIF_Shared_State_Set_GUID * guid);

  void  add_Callback(CIF_Shared_State_Callback_Interface * callback);
  void  remove_Callback(CIF_Shared_State_Callback_Interface * callback);
};

#endif
