#include "CIF_Shared_State_def.H"

CIF_Shared_State_Base::CIF_Shared_State_Base()
{
    globus_mutex_init(&mutex, GLOBUS_NULL);
    globus_mutex_init(&re_mutex, GLOBUS_NULL);
    globus_cond_init(&cond, GLOBUS_NULL);
    threadID = -1;
}

CIF_Shared_State_Base::~CIF_Shared_State_Base()
{
    globus_mutex_destroy(&mutex);
    globus_mutex_destroy(&re_mutex);
    globus_cond_destroy(&cond);
}

void
CIF_Shared_State_Base::lock()
{
/*    globus_bool_t                         getLock = GLOBUS_FALSE;
    globus_mutex_lock(&re_mutex);
    {
        if(threadID == globus_thread_self())
	{
            lockedCount++;
	}
	else
	{
	    getLock = GLOBUS_TRUE;
	}
    }
    globus_mutex_unlock(&re_mutex);
    if(getLock)
    {
        globus_mutex_lock(&mutex);
	if(lockedCount != 0)
	{
	    globus_libc_printf("ERROR in reentrant lock\n");
	    assert(0);
        }
	lockedCount++;
    }
*/
    globus_mutex_lock(&mutex);
}


void
CIF_Shared_State_Base::unlock()
{
/*
    globus_mutex_lock(&re_mutex);
    {
	if(threadID != globus_thread_self())
	{
	    globus_libc_printf("you do not own the lock\n");
        }
	lockedCount--;
        if(lockedCount == 0)
	{
            globus_mutex_unlock(&mutex);
	}
    }
    globus_mutex_unlock(&re_mutex);
*/
    globus_mutex_unlock(&mutex);
}

void
CIF_Shared_State_Base::wait()
{
    done = GLOBUS_FALSE;
    while(!done)
    {
        globus_cond_wait(&cond, &mutex);
    }
}

void
CIF_Shared_State_Base::notify()
{
    done = GLOBUS_TRUE;
    globus_cond_signal(&cond);
}
