/******************************************************************************
  CIF_Shared_State_Double.h
  ----------------------
    
  Description:
      
    Float Array Shared_State implementation
	  
  CVS Information:
	    
    $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/shared_state/CIF_Shared_State_Double.H,v $
    $Date: 2000/02/20 20:51:16 $
    $Revision: 1.4 $
    $State: Exp $
    $Author: bresnaha $
******************************************************************************/
#ifndef __CIF_SHARED_STATE_DOUBLE
#define __CIF_SHARED_STATE_DOUBLE

#include <stdio.h>
#include "CIF_Shared_State_def.H"
#include "nexus.h"

class CIF_Shared_State_Double : public CIF_Shared_State
{
protected:
  double *                                   state_Value;
  int                                       state_Count;

protected:

  CIF_Bool  pack_User_State(
                CIF_Shared_State_Serial *     serial, 
	        int                           dest_offset,
                double                         src_state[], 
	        int                           src_offset, 
	        int                           count);

public:
  CIF_Shared_State_Double(
      char *                                  name,
      int                                     size);

  CIF_Shared_State_Double(
      char *                                  name,
      double                                   init_val[],
      int                                     size);

  CIF_Shared_State_Double(
      char *                                    name,
      int                                       size,
      CIF_Shared_State_Callback_Interface *   callback);

  CIF_Shared_State_Double(
      char *                                  name,
      double                                   init_val[],
      int                                     size,
      CIF_Shared_State_Callback_Interface *    callback);

  
  ~CIF_Shared_State_Double();

  virtual int   get_State_Count()
		    { return state_Count;};

  CIF_Bool      get_State(
                    double                    dest_state[], 
	            int                      dest_offset,
		    int                      src_offset, 
		    int                      count);

  CIF_Bool      set_State_Changed(
                    int                     dest_offset, 
                    double                   src_state[], 
		    int                     src_offset, 
                    int                     count,
                    CIF_Shared_State_Changed_Type type);

  virtual void  pack_State(
                    CIF_Shared_State_Serial * serial);
  virtual void  unpack_State(
                    CIF_Shared_State_Serial * serial);
};

#endif
