/******************************************************************************
CIF_Shared_State_Serial.h

Description:

  Shared State packed buffer class.
  
  CVS Information:
	
  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/shared_state/CIF_Shared_State_Serial.H,v $
  $Date: 2000/02/20 20:51:18 $
  $Revision: 1.3 $
  $State: Exp $
  $Author: bresnaha $
******************************************************************************/
#ifndef __CIF_SHARED_STATE_SERIAL
#define __CIF_SHARED_STATE_SERIAL


class CIF_L_Buffer_List_Node
{
protected:
  int                        local_Size;
  int                        current_Offset;
  CIF_Byte *                 local_Buffer;

public:
  CIF_L_Buffer_List_Node *   next;

public:
  CIF_L_Buffer_List_Node(int size);
  CIF_L_Buffer_List_Node(CIF_Byte * value, int size);
  ~CIF_L_Buffer_List_Node();

  int        copy_Buffer(CIF_Byte * buf, int offset);
  CIF_Byte * get_User_Buffer(int size_request);
  CIF_Byte * get_User_Buffer();
  CIF_Byte * get_Buffer();
};

class CIF_L_Buffer_Manager
{
protected:
  int                      size_Used;
  int                      current_Size;
  int                      node_Size;
  CIF_L_Buffer_List_Node * first;
  CIF_L_Buffer_List_Node * current_Node;

public:
  CIF_L_Buffer_Manager(int  size);
  CIF_L_Buffer_Manager(CIF_Byte * in_value, int size);
  ~CIF_L_Buffer_Manager();

  CIF_Byte * get_Buffer();
  CIF_Byte * get_User_Buffer(int size_requested);
  CIF_Byte * get_User_Buffer();
  int        get_Size() 
	     {return size_Used;};
};

class CIF_Shared_State_Serial
{
protected:
   CIF_L_Buffer_Manager * buffer_Manager;
   int                        local_Format; 

public:
   CIF_Shared_State_Serial();
   CIF_Shared_State_Serial(CIF_Byte * value, int size);
   ~CIF_Shared_State_Serial();

   CIF_Byte *  get_Buffer();
   int         get_Size_Buffer();
   void        set_Sequence_Number(long seq_num);

   void unpack_Byte(CIF_Byte value[], int offset, int count);
   void unpack_Char(char value[], int offset, int count);
   void unpack_Bool(CIF_Bool value[], int offset, int count);
   void unpack_Short(short value[], int offset, int count);
   void unpack_Int(int value[], int offset, int count);
   void unpack_Long(long value[], int offset, int count);
   void unpack_Float(float value[], int offset, int count);
   void unpack_Double(double value[], int offset, int count);

   void pack_Byte(CIF_Byte value[], int offset, int count);
   void pack_Char(char value[], int offset, int count);
   void pack_Bool(CIF_Bool value[], int offset, int count);
   void pack_Short(short value[], int offset, int count);
   void pack_Int(int value[], int offset, int count);
   void pack_Long(long value[], int offset, int count);
   void pack_Float(float value[], int offset, int count);
   void pack_Double(double value[], int offset, int count);
};

#endif
