/******************************************************************************
  CIF_Shared_State_Set.h
  ----------------------
    
  Description:
      
    Shared_State_Set class.
	  
  CVS Information:
	    
    $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/shared_state/CIF_Shared_State_Set.H,v $
    $Date: 2000/02/23 05:41:43 $
    $Revision: 1.5 $
    $State: Exp $
    $Author: bresnaha $
******************************************************************************/
#ifndef __CIF_SHARED_STATE_SET
#define __CIF_SHARED_STATE_SET

/******************************************************************************
*  Class prototypes
*  ----------------
******************************************************************************/
class CIF_Shared_State;
class CIF_Shared_State_Base;
class CIF_Shared_State_Set_GUID;
class CIF_Shared_State_Messenger_Interface;
class CIF_Shared_State_Serial;
class I_CIF_Hash_Table;

#define  CIF_SHARED_STATE_HASH_TABLE_SIZE  512

#include "CIF_Shared_State_def.H"

/******************************************************************************
*  CIF_Shared_State_Set
*  --------------------
******************************************************************************/
class CIF_Shared_State_Set : public CIF_Shared_State_Set_Event_Listener,
		     public CIF_Shared_State_Base
{
protected:
    char *                                     message_Space_Url;
    CIF_I_Hash_Table *                         hash_Table;
    CIF_Shared_State_Messenger_Interface *     messenger;
    CIF_Shared_State_Set_GUID *                guid;
    CIF_I_List *                               listeners;
    globus_mutex_t                             mutex;
    globus_cond_t                              cond;

protected:
    void init();

public:
    CIF_Shared_State_Set(
        CIF_Messenger_Protocol                protocol);
    CIF_Shared_State_Set(
        CIF_Messenger_Protocol                protocol, 
        char *                                url);

    virtual ~CIF_Shared_State_Set();

    virtual void state_Change_Occurred(
        char *                                state_name, 
        CIF_Shared_State_Set_GUID *           guid);
    virtual void set_Joined(
        CIF_Shared_State_Set_GUID *           guid);
    virtual void set_Exited(
        CIF_Shared_State_Set_GUID *           guid);
    virtual void state_Added(
        char *                                state_name, 
        CIF_Shared_State_Set_GUID *           source_set);

    void add_Set_Event_Listener(
        CIF_Shared_State_Set_Event_Listener * l);
    void remove_Set_Event_Listener(
        CIF_Shared_State_Set_Event_Listener * l);
    void pack_User_Set(
        CIF_Shared_State_Serial *             serial, 
        CIF_Shared_State *                    state);

    CIF_Bool  poll();

    CIF_Shared_State_Set_GUID * get_GUID();

    char * get_Message_Space_URL();
    void   add_Shared_State(CIF_Shared_State * shared_state);

    CIF_Shared_State * get_Shared_State(
        char * shared_state_name);
    CIF_Shared_State **                get_Shared_States();
    int                                get_Shared_State_Count();

    virtual CIF_Shared_State_Serial * 
    new_Shared_State_Serial(
        CIF_Shared_State *             shared_state);

    void receive(CIF_Shared_State_Serial * serial, 
	       CIF_Shared_State_Changed_Type type,
	       long seq_num);
    void set_State_Changed(CIF_Shared_State_Serial * serial,
			 CIF_Shared_State_Changed_Type type);

    void close();

    void set_Initalized(
	     CIF_Bool                      b);
    CIF_Bool get_Initalized();
};

#endif
