#ifndef __CIF_CONTROLS 
#define __CIF_CONTROLS

#include <stdlib.h>
#include <string.h>
#include <CIF_Comm.H>
#if defined(HAVE_IOSTREAM)
#    include <iostream.h>
#endif
#include <globus_common.h>

#define CIF_CONTROLS_INITIAL_MESSAGE_SIZE 4096
#define DEBUG 1

#if defined(DEBUG) 
#    if defined(HAVE_IOSTREAM)
#        define DebugPrint(str) \
         {\
             cout << "CIF_SHARED_STATE#" << getpid() << ">" << str << "\n"; \
         }
#    else
#        define DebugPrint(str)
#    endif
#endif

enum CIF_Messenger_Protocol
{
   CIF_MESSENGER_TYPE_DUMMY,
   CIF_MESSENGER_TYPE_TCP
};

enum CIF_Shared_State_Changed_Type
{
    INTERMEDIATE,
    FINAL,
    INITIALIZE,
    NAK_INITIALIZE
};

#include "CIF_Shared_State_Base.H"
#include "CIF_I_Shared_State_Tools.H"
#include "CIF_Shared_State_Set_Event_Listener.H"
#include "CIF_Shared_State_Set.H"
#include "CIF_Shared_State_Set_GUID.H"
#include "CIF_Shared_State_Messenger_Interface.H"
#include "CIF_Shared_State_Callback_Interface.H"
#include "CIF_Messenger_Dummy.H"
#include "CIF_Shared_State.H"
#include "CIF_Messenger_TCP.H"

#include "CIF_Shared_State_Int.H"
#include "CIF_Shared_State_Float.H"
#include "CIF_Shared_State_Short.H"
#include "CIF_Shared_State_Long.H"
#include "CIF_Shared_State_Double.H"

#include "CIF_Shared_State_Char.H"
#include "CIF_Shared_State_Byte.H"
#include "CIF_Shared_State_Bool.H"
#include "CIF_Shared_State_Serial.H"

#endif
