/******************************************************************************
Description:

  Top level CIF class definition

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit.C,v $
  $Date: 2000/01/14 13:08:40 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#include "CIF_Toolkit.H"
#include "globus_common.h"

extern "C"
{
    static int l_activate();
    static int l_deactivate();
}    

static globus_module_descriptor_t l_module_descriptor =
{
    "CIF_Toolkit",
    l_activate,
    l_deactivate,
    GLOBUS_NULL
};


CIF_Bool
CIF_Toolkit::activate()
{
    int						rc;
    
    rc = globus_module_activate(&l_module_descriptor);
    return (rc == GLOBUS_SUCCESS) ? true : false;
}


CIF_Bool
CIF_Toolkit::deactivate()
{
    int						rc;
    
    rc = globus_module_deactivate(&l_module_descriptor);
    return (rc == GLOBUS_SUCCESS) ? true : false;
}


void
CIF_Toolkit::poll()
{
    globus_poll();
}


static
int
l_activate()
{
    if (globus_module_activate(GLOBUS_COMMON_MODULE) != GLOBUS_SUCCESS)
    {
	return GLOBUS_FAILURE;
    }

    return GLOBUS_SUCCESS;
}

static
int
l_deactivate()
{
    if (globus_module_deactivate(GLOBUS_COMMON_MODULE) != GLOBUS_SUCCESS)
    {
	return GLOBUS_FAILURE;
    }

    return GLOBUS_SUCCESS;
}

