/******************************************************************************
CIF_Toolkit_Cond.H

Description:

  A condition variable class used to wait for and signal condition changes
  
CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit_Cond.H,v $
  $Date: 1998/09/25 15:08:51 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_TOOLKIT_COND)
#define CIF_INCLUDE_TOOLKIT_COND 1

#include "CIF_Toolkit.H"

class CIF_Toolkit_Cond
: public CIF_Toolkit_Object
{
    public:
    CIF_Toolkit_Cond();
    
    public:
    ~CIF_Toolkit_Cond();

    public:
    void
    wait(
	ARG_INMOD CIF_Toolkit_Mutex &		mutex,
	ARG_IN const CIF_Toolkit_Timeout &	timeout = (
	    CIF_Toolkit_Timeout::INFINITY));

    public:
    void
    signal();

    public:
    void
    broadcast();

    private:
    globus_cond_t				l_cond;
};

#endif  /*CIF_INCLUDE_TOOLKIT_COND */

