/******************************************************************************
CIF_Toolkit_Event.H

Description:

  A simple event and event listener interface.  Event listeners are used to
  signal when an event has occurred.  A listener is allowed to perform
  computations in response to an event; however, the event handling method must
  not perform any blocking operations.  Not observing this rule, may result in
  an internal deadlock.  The internal object make an attempt to identify
  obvious deadlock conditions, however complex deadlock avoidence is left to
  the user.

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit_Event.H,v $
  $Date: 1998/09/25 18:32:00 $
  $Revision: 1.3 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_TOOLKIT_EVENT)
#define CIF_INCLUDE_TOOLKIT_EVENT 1

#include "CIF_Toolkit.H"

class CIF_Toolkit_Event
: public CIF_Toolkit_Object
{
    public:
    static const CIF_Toolkit_UUID		CLASS_ID;

    CIF_Toolkit_Event();
};

class CIF_Toolkit_Event_Listener
: public CIF_Toolkit_Object
{
    public: virtual
    void
    handle_Event(
	ARG_INMOD CIF_Toolkit_Event &		event) = 0;
};

#endif  /*CIF_INCLUDE_TOOLKIT_EVENT */

