/******************************************************************************
CIF_Toolkit_Monitor.H

Description:

  A simple monitor class built using CIF toolkit mutexes and condition
  variables

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit_Monitor.H,v $
  $Date: 1998/09/25 15:08:52 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_TOOLKIT_MONITOR)
#define CIF_INCLUDE_TOOLKIT_MONITOR 1

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Toolkit.H"


/******************************************************************************
		       Define CIF_Toolkit_Monitor class
******************************************************************************/
class
CIF_Toolkit_Monitor
{
    public:
    CIF_Toolkit_Monitor(
	ARG_INMOD CIF_Toolkit_Mutex &		mutex);

    public:
    CIF_Toolkit_Monitor(
	ARG_INMOD CIF_Toolkit_Mutex &		mutex,
	ARG_INMOD CIF_Toolkit_Cond &		cond);

    public:
    ~CIF_Toolkit_Monitor();
    
    public:
    void
    wait(
	ARG_IN const CIF_Toolkit_Timeout &	timeout = (
	    CIF_Toolkit_Timeout::INFINITY));
    
    public:
    void
    signal();

    public:
    void
    broadcast();
    
    private:
    CIF_Toolkit_Mutex *				l_mutex;
    CIF_Toolkit_Cond *				l_cond;
};

#endif /* CIF_INCLUDE_TOOLKIT_MONITOR */
