/******************************************************************************
CIF_Toolkit_Object.H

Description:

  A generic CIF object.  Eventually, this will be used to identify objects and
  object hierarchies.  This will be accomplished by having each a UUID
  associated with each object definition and then requiring that the object
  constructors add their associated UUID to an ID list.

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit_Object.H,v $
  $Date: 1998/09/28 20:16:39 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_TOOLKIT_OBJECT)
#define CIF_INCLUDE_TOOLKIT_OBJECT 1

#include "CIF_Toolkit_defs.H"
#include "CIF_Toolkit_UUID.H"
#include "globus_common.h"


class CIF_Toolkit_Object
{
    public:
    CIF_Toolkit_Object();

    public: virtual
    ~CIF_Toolkit_Object();

    public:
    CIF_Bool
    is_Member(
	ARG_IN const CIF_Toolkit_UUID &		object_uuid);

    protected:
    void
    add_Member(
	ARG_IN const CIF_Toolkit_UUID *		object_uuid);

    private: static
    int
    compare_Members(
	void *					uuid_ptr1,
	void *					uuid_ptr2);
    
    private:
    globus_list_t *				member_list;
};

#endif  /*CIF_INCLUDE_TOOLKIT_OBJECT */

