/******************************************************************************
CIF_Toolkit_UUID.C

Description:

  Definition for universally unique IDs.  Among other things, these are used by
  CIF to track membership of an object within an object hierarchy.

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit_UUID.C,v $
  $Date: 1998/09/25 20:38:12 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#include "CIF_Toolkit_UUID.H"
#include <string.h>
#include <stdio.h>

CIF_Toolkit_UUID::CIF_Toolkit_UUID(
    const char *				uuid)
{
    int						i;
    unsigned int				x;

    if (strlen(uuid) != 36)
    {
	goto fn_error;
    }
    
    for (i = 0; i < 4; i++)
    {
	if (sscanf(&uuid[i * 2 + 0], "%2x", &x) != 1)
	{
	    goto fn_error;
	}

	l_uuid[i] = x;
    }
    
    for (i = 4; i < 6; i++)
    {
	if (sscanf(&uuid[i * 2 + 1], "%2x", &x) != 1)
	{
	    goto fn_error;
	}

    	l_uuid[i] = x;
    }

    for (i = 6; i < 8; i++)
    {
	if (sscanf(&uuid[i * 2 + 2], "%2x", &x) != 1)
	{
	    goto fn_error;
	}

    	l_uuid[i] = x;
    }
    
    for (i = 8; i < 10; i++)
    {
	if (sscanf(&uuid[i * 2 + 3], "%2x", &x) != 1)
	{
	    goto fn_error;
	}

    	l_uuid[i] = x;
    }

    for (i = 10; i < 16; i++)
    {
	if (sscanf(&uuid[i * 2 + 4], "%2x", &x) != 1)
	{
	    goto fn_error;
	}

    	l_uuid[i] = x;
    }

    return;

  fn_error:
    for (i = 0; i < 16; i++)
    {
    	l_uuid[i] = 0xff;
    }
}

CIF_Bool
operator ==(
    ARG_IN const CIF_Toolkit_UUID &		uuid1,
    ARG_IN const CIF_Toolkit_UUID &		uuid2)
{
    int						i;

    for (i = 0; i < 16; i++)
    {
	if (uuid1.l_uuid[i] != uuid2.l_uuid[i])
	{
	    return false;
	}
    }

    return true;
}
