/******************************************************************************
CIF_Toolkit_UUID.H

Description:

  Definition for universally unique IDs.  Among other things, these are used by
  CIF to track membership of an object within an object hierarchy.

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/cpp/libraries/toolkit/CIF_Toolkit_UUID.H,v $
  $Date: 1998/10/27 16:15:03 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_TOOLKIT_UUID)
#define CIF_INCLUDE_TOOLKIT_UUID 1

#include "CIF_Toolkit_defs.H"


class CIF_Toolkit_UUID
{
    /*
     * CIF_Toolkit_UUID::CIF_Toolkit_UUID()
     *
     * Convert from a string format to an internal representation.  All digits
     * must be specified, so leading zeros should be used to pad any fields
     * that are not the correct length.
     *
     * example: "2ccc1520-4725-11d2-b39a-0020d8000a91"
     */
    public:
    CIF_Toolkit_UUID(
	const char *				uuid_string);

    /*
     * CIF_Toolkit_UUID::==()
     *
     * Compare two UUID objects, returning true if they are the same and false
     * otherwise
     */
    friend
    CIF_Bool
    operator ==(
	ARG_IN const CIF_Toolkit_UUID &		uuid1,
	ARG_IN const CIF_Toolkit_UUID &		uuid2);
	
    private:
    unsigned char				l_uuid[16];
};
#endif  /*CIF_INCLUDE_TOOLKIT_UUID */

