import java.awt.*;
import java.awt.event.*;
import cif.shared_state.*;
import cif.shared_state.primative.*;
import java.util.Vector;

class Shared_Slider extends Panel 
    implements Callback_Interface, AdjustmentListener                       
{
    // format:
    // 0 - val
    // 1 - min
    // 2 - max
    protected  State_Int    sharedInt = null;
    protected  Set          set;
    protected  String       name;
    protected  I_Slider     scrollBar;

    protected  float        scale;
    protected  float        min;
    protected  float        max;

    protected  int          clickCount = 25;

    protected  boolean       fireFlag = true;
    
    class I_Slider extends Scrollbar
    {
        boolean fire = true;

        public I_Slider(int or, int min, int max, int val)
        {
            super(or, val, 1, min, max);
        }

        public void processEvent(AWTEvent e)
        {
	    //	    System.out.println("process event");
            if(!fire) return;
	    // System.out.println("process event 2");

            super.processEvent(e);
        }

        public void setValue(int value, boolean fire_event)
        {
            boolean prev = fire;
                
            fire = fire_event;
	    System.out.println("setting scrollbar");
            super.setValue(value);
            fire = prev;
        }
    }

    public Shared_Slider(float val,
                      float min,
                      float max,
                      int   click_count,
                      Set set, 
                      String name)
    {
        super();
        int spot;

        clickCount = click_count;
        this.max = max;
        this.min = min;
        this.scale = (max - min) / clickCount;

        spot = (int)(val / scale + min);
        scrollBar = new I_Slider(Scrollbar.VERTICAL, 0, clickCount, spot);
	scrollBar.addAdjustmentListener(this);
        
        this.name = new String(name);

        this.set = set;
        
        this.setLayout(new BorderLayout(5, 5));
        this.add("Center", scrollBar);
   }

    private String precVal(float x)
    {
        int temp = (int)(x * 100);
        x = (float) temp / 100.0f;

        String code = new Float(x).toString();

        return code;
    }

    public void start_Sharing()
    {
        int temp_val[] = new int[1];
        temp_val[0] = scrollBar.getValue();

        sharedInt = new State_Int(name, temp_val, 1, this);
	set.add_Shared_State(sharedInt);
	
    }

    public synchronized void addAdjustmentListener(AdjustmentListener l)
    {
        scrollBar.addAdjustmentListener(l);
    }

    public synchronized void removeAdjustmentListener(AdjustmentListener l)
    {
        scrollBar.removeAdjustmentListener(l);
    }

    public void setEnabled(boolean b)
    {
        super.setEnabled(b);
        
        scrollBar.setEnabled(b);
    }


    public synchronized void state_Changed(State state,
                                           int state_changed_type,
                                           Set_GUID guid)
    {
        int temp_val[] = new int[1];


        if(sharedInt == null) return;

        sharedInt.get_State(temp_val, 0, 0, 1);

        if(guid == null || guid.equals(set.get_GUID())) 
        {                  
            return;
        }

        scrollBar.removeAdjustmentListener(this);
        fireFlag = false;
        int spot = (int) ((temp_val[0] - min) / scale);
        scrollBar.setValue(temp_val[0]);
        scrollBar.addAdjustmentListener(this);
    } 

    public synchronized void adjustmentValueChanged(AdjustmentEvent event)
    {
        int value[] = new int[1];
        value[0] = scrollBar.getValue();
        
	System.out.println("adjust value changed");

        if(!fireFlag)
        {
            fireFlag = true;
	    //    return;
        }
        if(scrollBar != event.getSource()) return;

	if(sharedInt != null)
	    {
	    sharedInt.set_State_Changed(0, value, 0, 1, State.FINAL); 
	    System.out.println("sending message change");
	    }
    }


    public int getValue()
    {
        return scrollBar.getValue(); 

    }


    public void setValue(int val)
    {
	scrollBar.removeAdjustmentListener(this);
        scrollBar.setValue(val);
	scrollBar.addAdjustmentListener(this);
    }

    public void setNoFireValue(int val)
    {
        scrollBar.removeAdjustmentListener(this);
        scrollBar.setValue(val);
        scrollBar.addAdjustmentListener(this);
    }       
}
