import cif.shared_state.*;
import cif.shared_state.primative.*;
import java.awt.*;
import java.awt.event.*;

class SliderTest implements ActionListener,
			    WindowListener
{
    private static final int MAX_SLIDERS = 15;

    protected Frame f;
    protected Shared_Slider  slider[] = new Shared_Slider[MAX_SLIDERS];
    protected Set            sharedSet;
    protected int            number_Used = 0;
    protected Button         button = new Button("Add");
    protected Panel          top = new Panel();


    public SliderTest()
    {
	try
	{
	    sharedSet = new Set(Set.CIF_MESSENGER_TYPE_TCP);
	    System.out.println(sharedSet.get_Message_Space_URL());
	}
	catch(Exception e) 
	{
	    System.out.println("Error in connection");
	    e.printStackTrace();
	}

	init();
    }

    public SliderTest(String url)
    {
	try {
	    System.out.println("make Set");
	    sharedSet = new Set(Set.CIF_MESSENGER_TYPE_TCP, url);
	    System.out.println("post make Set");
	}catch(Exception e) {}

	init();
    }

    private void init()
    {
	int ctr;
	String name;
	Panel bottom = new Panel();

	top.setLayout(new GridLayout(1, MAX_SLIDERS, 10, 10));
	f = new Frame("Slider Test");
	f.setLayout(new BorderLayout());
	f.setBackground(Color.red);
	f.add("Center", top);
	f.add("South", bottom);
	bottom.add(button);

	for(ctr = 0; ctr < 5; ctr++)
	{
	    name = new String("S");
	    name = name.concat(new Integer(ctr).toString());
	    slider[ctr] = new Shared_Slider(0.5f, 0.0f, 
					 10.0f, 10, sharedSet, name); 
	    slider[ctr].start_Sharing();
	    top.add(slider[ctr]);
	    number_Used++;
	}	

	button.addActionListener(this);
	f.setSize(300, 300);
	f.show();
	f.addWindowListener(this);
    }

    public static void main(String argv[])
    {
	System.out.println("Starting slider test");
	if(argv.length < 1)
	{
	    new SliderTest();
	}
	else
        {
	    new SliderTest(argv[0]);
	}
	
	System.out.println("Ending SliderTest");
    }

    public void actionPerformed(ActionEvent e)
    {
       

	String name = new String("SLIDER_");
	name = name.concat(new Integer(number_Used).toString());

	System.out.println("adding state:" + name + ":");
	slider[number_Used] = new Shared_Slider(0.5f, 0.0f, 
				     10.0f, 10, sharedSet, name); 
	slider[number_Used].start_Sharing();
	top.add(slider[number_Used]);
	number_Used++;
	if(number_Used >= MAX_SLIDERS) 
	{
	    System.out.println("no more sliders can be added");
	    button.setEnabled(false);
	}

	f.show();
    }

    public void windowActivated(WindowEvent e)
    {
    }

    public void windowClosed(WindowEvent e)
    {
	System.exit(1);
    }

    public void windowClosing(WindowEvent e)
    {
	System.out.println("window closed");
	f.dispose();
	sharedSet.close();
    }
    
    public void windowDeactivated(WindowEvent e)
    {
    }

    public void windowDeiconified(WindowEvent e)
    {
    }

    public void windowIconified(WindowEvent e)
    {
    }

    public void windowOpened(WindowEvent e)
    {
    }
}
