package cif.comm;

import cif.toolkit.*;
import nexus.*;

class Test_NSML_Attach
extends
    Test_NSML
implements
    Event_Listener
{
    public
    Test_NSML_Attach()
    {
	super();
    }

    public
    void
    run_Test(
	int					msg_cnt,
	Timeout					timeout)
    throws
	java.lang.Exception
    {
	
	I_Endpoint_Properties			properties;
	String					host;
	int					port;

	properties = new I_Endpoint_Properties();
	properties.enable_Attach();
	properties.set_Protocol(new UdpInfo());
	properties.set_Event_Listener(this);

	i_ep.activate(properties);
	System.out.println("endpoint.activate(): completed");

	host = i_ep.get_Attach_Hostname();
	port = i_ep.get_Attach_Port();
	
	System.out.println("ep.get_Attach_info(): " +
			   "host=" + host + ", port=" + port);

	i_sp.activate(host, port);
	System.out.println("startpoint.activate(): completed");

	super.run_Test(msg_cnt, timeout);
	
	i_sp.deactivate();
	System.out.println("startpoint.deactivate(): completed");

    	i_ep.deactivate();
	System.out.println("endpoint.deactivate(): completed");
    }

    public
    void
    handle_Event(
	Event					event)
    {
	System.out.println("Test_NSML_Attach.handle_Event(): called");
    }

    public static final
    void
    main(
	String []				args)
    throws
	Exception    
    {
	Test_NSML_Attach			test;
	int					msg_cnt;
	Timeout					timeout;

	if (args.length < 1 || args.length > 2)
	{
	    System.err.println("usage: Test_NSML_Attach <count> [timeout]");
	    System.exit(1);
	}

	msg_cnt = Integer.parseInt(args[0]);
	if (args.length == 2)
	{
	    timeout = new Timeout(Integer.parseInt(args[0]));
	}
	else
	{
	    timeout = new Timeout(Timeout.INFINITY);
	}
	
	Comm.activate();

	test = new Test_NSML_Attach();
	test.run_Test(msg_cnt, timeout);

	Comm.deactivate();
    }
    
}
