package cif.comm;

import cif.toolkit.*;
import nexus.*;



class Test_NSML_Get
extends
    Test_NSML
implements
    Event_Listener
{
    public
    Test_NSML_Get()
    {
	super();
    }

    public
    void
    run_Test(
	int					msg_cnt,
	Timeout					timeout)
    throws
	java.lang.Exception
    {
	
	I_Endpoint_Properties			properties;
	String					host;
	int					port;

	I_Startpoint				sp1;
	I_Startpoint				sp2;

	sp1 = new I_Startpoint();
	sp2 = new I_Startpoint();

	properties = new I_Endpoint_Properties();
	properties.set_Protocol(new UdpInfo());
	properties.set_Event_Listener(this);

	i_ep.activate(properties);
	System.out.println("endtpoint.activate(): completed");

	sp1.activate(i_ep);
	sp2.activate(i_ep);

	Nexus					nx;
	PutBuffer				nx_put_buf;
	GetBuffer				nx_get_buf;

	nx = Comm.acquire_Nexus();
	
	nx_put_buf = nx.buffer_init(sp2.sizeof(), 0);
	sp2.put(nx_put_buf);
	sp1.send(nx_put_buf);
	sp1.deactivate();


	nx_get_buf = i_ep.receive(timeout);
	
	i_sp.activate(nx_get_buf);
	System.out.println("startpoint.activate(): completed");
	
	Comm.release_Nexus();
	
	super.run_Test(msg_cnt, timeout);
	
	i_sp.deactivate();
	System.out.println("startpoint.deactivate(): completed");

    	i_ep.deactivate();
	System.out.println("endpoint.deactivate(): completed");
    }

    public
    void
    handle_Event(
	Event					event)
    {
	System.out.println("Test_NSML_Get.handle_Event(): called");
    }

    public static final
    void
    main(
	String []				args)
    throws
	Exception    
    {
	Test_NSML_Get				test;
	int					msg_cnt;
	Timeout					timeout;

	if (args.length < 1 || args.length > 2)
	{
	    System.err.println("usage: Test_NSML_Get <count> [timeout]");
	    System.exit(1);
	}

	msg_cnt = Integer.parseInt(args[0]);
	if (args.length == 2)
	{
	    timeout = new Timeout(Integer.parseInt(args[1]));
	}
	else
	{
	    timeout = new Timeout(Timeout.INFINITY);
	}
	
	Comm.activate();

	test = new Test_NSML_Get();
	test.run_Test(msg_cnt, timeout);

	Comm.deactivate();
    }
}
