package cif.shared_state.messenger;

import java.lang.*;
import cif.shared_state.*;

/**
   This messenger creates a single node message space.  When a 
   message is sent it is imediatly returned to the set.  This class
   is mainly used for testing.
*/

//*************************************************************************
//*  CIF.Shared_State.Messenger_Dummy
//*  --------------------------------
//*************************************************************************
public class Messenger_Dummy implements Messenger_Interface
{
    protected  Set      shared_State_Set;
    protected  String   space_Url;
    protected  int      msg_Num = 1;  

   /*
    *
    */
    public 
    Messenger_Dummy(Set shared_state_set)
    {
        shared_State_Set = shared_state_set;
        space_Url = "Dummy URL";
    }

   /*
    *
    */
    public 
    Messenger_Dummy(Set shared_state_set, 
                  String url)
    {
        shared_State_Set = shared_state_set;
        space_Url = new String(url);
    }

   /*
    *
    */
    public String 
    get_Message_Space_URL()
    {
        return space_Url;
    }

   /*
    *
    */
    public 
    boolean poll()
    {
        return false;
    }

   /*
    *
    */
    public void 
    add_Shared_State(State state)
    {
    }

   /*
    *
    */
    public void 
    send(Serial serial, int state_changed_type)
    {
        shared_State_Set.receive(new Serial(serial.get_Buffer(),
                                            serial.get_Size_Buffer()),
                                 state_changed_type,
				 msg_Num);
	msg_Num++;
    }

   /*
    *
    */
    public Serial 
    new_Shared_State_Serial()
    {
        return new Serial();
    }

    public void close()
    {

    }
}

