/******************************************************************************
Queue.java

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/java/libraries/cif/toolkit/Queue.java,v $
  $Date: 1998/10/13 22:56:34 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

package cif.toolkit;


/**
 * Generic FIFO queue which is used internally by CIF.
 */
public class Queue
{
    private class L_Queue_Entry
    {
	public java.lang.Object			data;
	public L_Queue_Entry			next;
    }

    public
    Queue()
    {
	l_head = null;
	l_tail = null;
    }


    public void
    enqueue(
	Object					data)
    {
	L_Queue_Entry				entry;
	
	entry = new L_Queue_Entry();
	entry.data = data;
	entry.next = null;
	
	if (l_head == null)
	{
	    l_head = entry;
	}
	else
	{
	    l_tail.next = entry;
	}
	
	l_tail = entry;
    }


    public
    Object
    dequeue()
    {
	if (l_head != null)
	{
	    L_Queue_Entry			entry;

	    entry = l_head;
	    l_head = entry.next;

	    return entry.data;
	}
	else
	{
	    return null;
	}
    }

    public
    boolean
    empty()
    {
	return (l_head == null);
    }

    private L_Queue_Entry			l_head;
    private L_Queue_Entry			l_tail;
}

