/******************************************************************************
Timeout.java

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Current/java/libraries/cif/toolkit/Timeout.java,v $
  $Date: 1999/02/14 08:05:20 $
  $Revision: 1.3 $
  $State: Exp $
  $Author: bresnaha $
******************************************************************************/

package cif.toolkit;

public
class Timeout
{
    public static final long			INFINITY = Long.MAX_VALUE;
    
    public
    Timeout()
    {
	set(INFINITY);
    }

    public
    Timeout(
	long					timeout)
    {
	set(timeout);
    }

    public
    void
    set(
	long					timeout)
    {
	l_time_allotted = timeout;
	l_time_started = System.currentTimeMillis();
	l_is_expired = false;

    }
    
    public
    long
    get()
    {
	if (is_Infinity())
	{
	    return INFINITY;
	}

	long					time_current;
	long					time_remaining;

	time_current = System.currentTimeMillis();
	time_remaining = l_time_allotted - time_current + l_time_started;
	if (time_remaining < 0)
	{
	    time_remaining = 0;
	    l_is_expired = true;
	}
	
	return (time_remaining);
    }

    public
    boolean
    is_Infinity()
    {
	return l_time_allotted == INFINITY;
    }

    public
    boolean
    is_Expired()
    {
	if (l_is_expired)
	{
	    return true;
	}

	get();

	return l_is_expired;
    }

    private long				l_time_allotted;
    private long				l_time_started;
    private boolean				l_is_expired;
}
