
package nexus;

import java.net.*;

/*
 * UdpInfo - UDP specific protocol information
 */
public
class UdpInfo
extends
    ProtoInfo
{

    public static final byte RESTRICT_TO_HOST      = 0x00;
    public static final byte RESTRICT_TO_SUBNET    = 0x01;
    public static final byte RESTRICT_TO_SITE      = 0x20;
    public static final byte RESTRICT_TO_REGION    = 0x40;
    public static final byte RESTRICT_TO_CONTINENT = (byte)0x80;
    public static final byte UNRESTRICTED          = (byte)0xFF;

    public int					port;
    public byte					ttl;
    public boolean				multiSender;
    public boolean				loopback;
    public InetAddress                          address;
    public String                               hostname;

    public UdpInfo()
    {
	protoType = Nexus.PROTO_TYPE_UDP;
	address = null;
	hostname = null;
	port = 0;
	ttl = RESTRICT_TO_SUBNET;
	multiSender = true;
	loopback = true;
    }
}
/* UdpInfo */
  
